image: docker:19.03.1

services:
  - docker:19.03.1-dind

variables:
  # When using dind service we need to instruct docker, to talk with the
  # daemon started inside of the service. The daemon is available with
  # a network connection instead of the default /var/run/docker.sock socket.
  #
  # The 'docker' hostname is the alias of the service container as described at
  # https://docs.gitlab.com/ee/ci/docker/using_docker_images.html#accessing-the-services
  #
  # Note that if you're using the Kubernetes executor, the variable should be set to
  # tcp://localhost:2375 because of how the Kubernetes executor connects services
  # to the job container
  # DOCKER_HOST: tcp://localhost:2375
  #
  # For non-Kubernetes executors, we use tcp://docker:2375
  DOCKER_HOST: tcp://docker:2375
  #
  # This will instruct Docker not to start over TLS.
  DOCKER_TLS_CERTDIR: ""


before_script:
  - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  ##
  ## Install ssh-agent if not already installed, it is required by Docker.
  ## (change apt-get to yum if you use an RPM-based image)
  ##
  - 'which ssh-agent || ( apk update && apk add openssh )'

  ##
  ## Run ssh-agent (inside the build environment)
  ##
  - eval $(ssh-agent -s)

  ##
  ## Add the SSH key stored in SSH_PRIVATE_KEY variable to the agent store
  ## We're using tr to fix line endings which makes ed25519 keys work
  ## without extra base64 encoding.
  ## https://gitlab.com/gitlab-examples/ssh-private-key/issues/1#note_48526556
  ##
  - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -

  ##
  ## Create the SSH directory and give it the right permissions
  ##
  - mkdir -p ~/.ssh
  - chmod 700 ~/.ssh

  ##
  ## Optionally, if you will be using any Git commands, set the user name and
  ## and email.
  ##
  #- git config --global user.email "user@example.com"
  #- git config --global user.name "User name"
  - echo "$SSH_KNOWN_HOSTS" > ~/.ssh/known_hosts
  - chmod 644 ~/.ssh/known_hosts

stages:
  - build
  - deploy

build-nginx:
  stage: build
  only:
    - dev
  script:
    - cp frontend/.env.dev frontend/.env
    - docker run --rm -v $(pwd)/frontend:/app -w /app node:12 npm i
    - docker run --rm -v $(pwd)/frontend:/app -w /app node:12 npm run build
    - docker build -f docker/nginx/DeployDockerfile -t registry.gitlab.com/itm21.top/psihos/nginx:latest .
    - docker push registry.gitlab.com/itm21.top/psihos/nginx:latest

build-php:
  stage: build
  only:
    - dev
  script:
    - cd backend
    - cp .env.dev .env
    - docker run --rm -v $(pwd):/app composer:2.0.8 install --ignore-platform-reqs
    - cd ..
    - docker build -f docker/php/Dockerfile -t registry.gitlab.com/itm21.top/psihos/php:latest .
    - docker push registry.gitlab.com/itm21.top/psihos/php:latest

deploy-dev:
  stage: deploy
  only:
    - dev
  script:
    - scp ./docker-compose-deploy.yml deploy@185.233.119.72:/home/deploy/
    - ssh deploy@185.233.119.72 "sudo docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY"
    - ssh deploy@185.233.119.72 "sudo docker-compose -f docker-compose-deploy.yml pull --parallel"
    - ssh deploy@185.233.119.72 "sudo docker-compose -f docker-compose-deploy.yml down"
    - ssh deploy@185.233.119.72 "sudo docker-compose -f docker-compose-deploy.yml up -d --force-recreate "

deploy-prod:
  stage: deploy
  only:
    - master
  script:
    - scp ./docker-compose-deploy.yml deploy@89.223.122.57:/home/deploy/
    - ssh deploy@89.223.122.57 "sudo docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY"
    - ssh deploy@89.223.122.57 "sudo docker-compose -f docker-compose-deploy.yml pull --parallel"
    - ssh deploy@89.223.122.57 "sudo docker-compose -f docker-compose-deploy.yml down"
    - ssh deploy@89.223.122.57 "sudo docker-compose -f docker-compose-deploy.yml up -d --force-recreate "

after_script:
  - docker system prune -f --volumes
